Package net.sf.saxon.trace

## Class TimingTraceListener

- java.lang.Object
- - net.sf.saxon.trace.TimingTraceListener

- All Implemented Interfaces:
    `java.util.EventListener`, `TraceListener`

      public class TimingTraceListener
      extends java.lang.Object
      implements TraceListener

  A trace listener that records timing information for templates and functions, outputting this information as an HTML report to a specified destination when the transformation completes.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected Configuration` | `config` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TimingTraceListener()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Called at end.
    `void` | `endCurrentItem​(Item item)` | Called after a node of the source tree got processed
    `void` | `enter​(Traceable instruction, java.util.Map<java.lang.String,​java.lang.Object> properties, XPathContext context)` | Called when an instruction in the stylesheet gets processed
    `void` | `leave​(Traceable instruction)` | Called after an instruction of the stylesheet got processed
    `void` | `open​(Controller controller)` | Called at start
    `void` | `setOutputDestination​(Logger stream)` | Set the PrintStream to which the output will be written.
    `void` | `startCurrentItem​(Item item)` | Called when an item becomes current

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.lib.TraceListener

      `endRuleSearch, startRuleSearch`

- - ### Field Detail

    - #### config

          protected Configuration config

  - ### Constructor Detail

    - #### TimingTraceListener

          public TimingTraceListener()

  - ### Method Detail

    - #### setOutputDestination

          public void setOutputDestination​(Logger stream)

      Set the PrintStream to which the output will be written.
      Specified by:
        `setOutputDestination` in interface `TraceListener`
      Parameters:
        `stream` - the PrintStream to be used for output. By default, the output is written to System.err.

    - #### open

          public void open​(Controller controller)

      Called at start
      Specified by:
        `open` in interface `TraceListener`
      Parameters:
        `controller` - identifies the transformation controller, and provides the listener with access to context and configuration information

    - #### close

          public void close()

      Called at end. This method builds the XML out and analyzed html output
      Specified by:
        `close` in interface `TraceListener`

    - #### enter

          public void enter​(Traceable instruction,
                            java.util.Map<java.lang.String,​java.lang.Object> properties,
                            XPathContext context)

      Called when an instruction in the stylesheet gets processed
      Specified by:
        `enter` in interface `TraceListener`
      Parameters:
        `instruction` - gives information about the instruction being executed, and about the context in which it is executed. This object is mutable, so if information from the InstructionInfo is to be retained, it must be copied.
        `properties` - extra information about the instruction to be included in the trace
        `context` - the XPath evaluation context

    - #### leave

          public void leave​(Traceable instruction)

      Called after an instruction of the stylesheet got processed
      Specified by:
        `leave` in interface `TraceListener`
      Parameters:
        `instruction` - the instruction or other construct that has now finished execution

    - #### startCurrentItem

          public void startCurrentItem​(Item item)

      Called when an item becomes current
      Specified by:
        `startCurrentItem` in interface `TraceListener`
      Parameters:
        `item` - the new current item. Item objects are not mutable; it is safe to retain a reference to the Item for later use.

    - #### endCurrentItem

          public void endCurrentItem​(Item item)

      Called after a node of the source tree got processed
      Specified by:
        `endCurrentItem` in interface `TraceListener`
      Parameters:
        `item` - the item that was current, whose processing is now complete. This will represent the same underlying item as the corresponding startCurrentItem() call, though it will not necessarily be the same actual object.